use flume::{Receiver, Sender};
use hexhex::print_hex;
use std::net::UdpSocket;
use std::thread::{self, JoinHandle};

fn listen() -> (JoinHandle<()>, Sender<Vec<u8>>, Receiver<Vec<u8>>) {
    let (tx, rx) = flume::unbounded();

    let tx_clone = tx.clone();
    let rx_clone = rx.clone();

    (
        thread::spawn(move || {
            let socket = UdpSocket::bind("127.0.0.1:13337").unwrap();

            dbg!(&socket);

            loop {
                let mut buf = [0; 256];
                //println!("[udp_socket] waiting for msg");
                let (len, _src) = socket.recv_from(&mut buf).unwrap();

                let buf = &mut buf[..len];
                tx.send(Vec::from(buf)).unwrap();
            }
        }),
        tx_clone,
        rx_clone,
    )
}

fn main() {
    let (thread_udp, _thread_udp_tx, thread_udp_rx) = listen();

    for msg in thread_udp_rx.iter() {
        print_hex(&msg);
    }

    let _ = thread_udp.join();
}
